Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato.F90	(revision 3605)
@@ -7,5 +7,5 @@
     USE phys_cal_mod, ONLY : mth_cur
     USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
-                                 grid2dto1d_glo
+                                 grid2dto1d_glo, grid_type, unstructured
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
@@ -15,5 +15,8 @@
     USE aero_mod
     USE dimphy
-
+    USE print_control_mod, ONLY: prt_level,lunout
+#ifdef CPP_XIOS
+    USE xios
+#endif
     implicit none
 
@@ -43,4 +46,5 @@
     real, allocatable:: tauaerstrat_mois(:, :, :)
     real, allocatable:: tauaerstrat_mois_glo(:, :)
+    real, allocatable:: tau_aer_strat_mpi(:, :)
 
 ! For NetCDF:
@@ -58,4 +62,7 @@
     data alpha_strat_wave/3.36780953,3.34667683,3.20444202,3.0293026,2.82108808/
 
+    CHARACTER (len = 20)                      :: modname = 'readaerosolstrato'
+    CHARACTER (len = 80)                      :: abort_message
+
 !--------------------------------------------------------
 
@@ -69,6 +76,6 @@
 
     IF (nbands.NE.2) THEN 
-        print *,'nbands doit etre egal a 2 dans readaerosolstrat'
-        STOP
+        abort_message='nbands doit etre egal a 2 dans readaerosolstrat'
+        CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -79,6 +86,6 @@
     n_lev = size(lev)
     IF (n_lev.NE.klev) THEN 
-       print *,'Le nombre de niveaux n est pas egal a klev'
-       STOP
+       abort_message='Le nombre de niveaux n est pas egal a klev'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -86,26 +93,30 @@
     CALL nf95_gw_var(ncid_in, varid, latitude)
     n_lat = size(latitude)
-    print *, 'LAT aerosol strato=', n_lat, latitude
-    IF (n_lat.NE.nbp_lat) THEN 
-       print *,'Le nombre de lat n est pas egal a nbp_lat'
-       STOP
-    ENDIF
-
+    WRITE(lunout,*) 'LAT aerosol strato=', n_lat, latitude
+    IF (grid_type/=unstructured) THEN
+      IF (n_lat.NE.nbp_lat) THEN 
+         abort_message='Le nombre de lat n est pas egal a nbp_lat'
+         CALL abort_physic(modname,abort_message,1)
+      ENDIF
+    ENDIF
+    
     CALL nf95_inq_varid(ncid_in, "LON", varid)
     CALL nf95_gw_var(ncid_in, varid, longitude)
     n_lon = size(longitude)
-    print *, 'LON aerosol strato=', n_lon, longitude
-    IF (n_lon.NE.nbp_lon) THEN 
-       print *,'Le nombre de lon n est pas egal a nbp_lon'
-       STOP
-    ENDIF
-
+    IF (grid_type/=unstructured) THEN
+      WRITE(lunout,*) 'LON aerosol strato=', n_lon, longitude
+      IF (n_lon.NE.nbp_lon) THEN 
+         abort_message='Le nombre de lon n est pas egal a nbp_lon'
+         CALL abort_physic(modname,abort_message,1)
+      ENDIF
+    ENDIF
+    
     CALL nf95_inq_varid(ncid_in, "TIME", varid)
     CALL nf95_gw_var(ncid_in, varid, time)
     n_month = size(time)
-    print *, 'TIME aerosol strato=', n_month, time
+    WRITE(lunout,*) 'TIME aerosol strato=', n_month, time
     IF (n_month.NE.12) THEN 
-       print *,'Le nombre de month n est pas egal a 12'
-       STOP
+       abort_message='Le nombre de month n est pas egal a 12'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -117,5 +128,5 @@
     CALL nf95_inq_varid(ncid_in, "TAUSTRAT", varid)
     ncerr = nf90_get_var(ncid_in, varid, tauaerstrat)
-    print *,'code erreur readaerosolstrato=', ncerr, varid
+    WRITE(lunout,*) 'code erreur readaerosolstrato=', ncerr, varid
 
     CALL nf95_close(ncid_in)
@@ -123,5 +134,5 @@
 !---select the correct month
     IF (mth_cur.LT.1.OR.mth_cur.GT.12) THEN
-      print *,'probleme avec le mois dans readaerosolstrat =', mth_cur
+     WRITE(lunout,*) 'probleme avec le mois dans readaerosolstrat =', mth_cur
     ENDIF
     tauaerstrat_mois(:,:,:) = tauaerstrat(:,:,:,mth_cur)
@@ -130,10 +141,25 @@
     CALL grid2dTo1d_glo(tauaerstrat_mois,tauaerstrat_mois_glo)
 
+    ELSE
+      ALLOCATE(tauaerstrat_mois(0,0,0))
     ENDIF !--is_mpi_root and is_omp_root
 
 !$OMP BARRIER
 
+    IF (grid_type==unstructured) THEN
+#ifdef CPP_XIOS
+      IF (is_omp_master) THEN
+        CALL xios_send_field("taustrat_in",tauaerstrat_mois)
+        ALLOCATE(tau_aer_strat_mpi(klon_mpi, klev))
+        CALL xios_recv_field("taustrat_out",tau_aer_strat_mpi)
+      ELSE
+        ALLOCATE(tau_aer_strat_mpi(0,0))
+      ENDIF
+      CALL scatter_omp(tau_aer_strat_mpi,tau_aer_strat)
+#endif
+    ELSE  
 !--scatter on all proc
-    CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
+      CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
+    ENDIF
 
 !--keep memory of previous month
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato_m.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato_m.F90	(revision 3605)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/readaerosolstrato_m.F90	(revision 3605)
@@ -0,0 +1,138 @@
+MODULE readaerosolstrato_m
+
+
+CONTAINS
+
+  SUBROUTINE init_readaerosolstrato(flag_aerosol_strat)
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  IMPLICIT NONE
+  INTEGER,INTENT(IN) :: flag_aerosol_strat
+    
+    IF (grid_type==unstructured)  THEN 
+   
+      IF (flag_aerosol_strat == 1) THEN
+        CALL init_readaerosolstrato1
+      ELSE IF (flag_aerosol_strat == 2) THEN
+        CALL init_readaerosolstrato2
+      ENDIF
+  
+    ENDIF
+  
+  END SUBROUTINE init_readaerosolstrato
+  
+
+
+  SUBROUTINE init_readaerosolstrato1
+#ifdef CPP_XIOS
+  USE netcdf
+  USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                      nf95_inq_varid, nf95_open
+  USE mod_phys_lmdz_para
+  USE xios
+!  USE YOERAD, ONLY : NLW
+  IMPLICIT NONE
+  REAL, POINTER:: latitude(:)
+  REAL, POINTER:: longitude(:)
+  INTEGER :: nlat, nlon
+  REAL    :: null_array(0)
+  INTEGER :: ncid_in, varid
+  
+    IF (is_omp_master) THEN  
+      IF (is_mpi_root) THEN
+        CALL nf95_open("taustrat.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "LON", varid)
+        CALL nf95_gw_var(ncid_in, varid, longitude)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        nlon=size(longitude)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(nlon)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_taustrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_taustrat",ni_glo=nlon, ni=nlon, ibegin=0, lonvalue_1d = longitude)
+       ELSE
+        CALL xios_set_domain_attr("domain_taustrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_taustrat",ni_glo=nlon, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+  
+      CALL xios_set_fieldgroup_attr("aerosol_strato1",enabled=.TRUE.)
+    ENDIF
+    
+#endif
+  END SUBROUTINE init_readaerosolstrato1
+  
+  SUBROUTINE init_readaerosolstrato2
+#ifdef CPP_XIOS
+  USE netcdf
+  USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                      nf95_inq_varid, nf95_open
+  USE mod_phys_lmdz_para
+  USE xios
+!  USE YOERAD, ONLY : NLW
+  IMPLICIT NONE
+  REAL, POINTER:: latitude(:)
+  REAL, POINTER:: wav(:)
+  INTEGER :: nlat,n_wav
+  REAL    :: null_array(0)
+  INTEGER :: ncid_in, varid
+
+    IF (is_omp_master) THEN    
+      IF (is_mpi_root) THEN
+        CALL nf95_open("tauswstrat.2D.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "WAV", varid)
+        CALL nf95_gw_var(ncid_in, varid, wav)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        n_wav = size(wav)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(n_wav)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_tauswstrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_tauswstrat",ni_glo=8, ni=8, ibegin=0, lonvalue_1d = (/ 0.,45.,90.,135.,180.,225.,270., 315. /))
+        DEALLOCATE(latitude)
+      ELSE
+        CALL xios_set_domain_attr("domain_tauswstrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_tauswstrat",ni_glo=8, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+      CALL  xios_set_axis_attr("nsw", n_glo=n_wav)
+    
+      IF (is_mpi_root) THEN
+        CALL nf95_open("taulwstrat.2D.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "WAV", varid)
+        CALL nf95_gw_var(ncid_in, varid, wav)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        n_wav = size(wav)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(n_wav)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_taulwstrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_taulwstrat",ni_glo=8, ni=8, ibegin=0, lonvalue_1d = (/ 0.,45.,90.,135.,180.,225.,270., 315. /))
+        DEALLOCATE(latitude)
+      ELSE
+        CALL xios_set_domain_attr("domain_taulwstrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_taulwstrat",ni_glo=8, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+    
+      CALL  xios_set_axis_attr("nlw", n_glo=n_wav)
+      CALL xios_set_fieldgroup_attr("aerosol_strato2",enabled=.TRUE.)
+
+    ENDIF
+#endif    
+  END SUBROUTINE init_readaerosolstrato2
+  
+
+END MODULE readaerosolstrato_m
+
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/readchlorophyll.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/readchlorophyll.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/readchlorophyll.F90	(revision 3605)
@@ -15,4 +15,5 @@
     USE mod_phys_lmdz_para, ONLY: scatter 
     USE phys_state_var_mod, ONLY: chl_con
+    USE print_control_mod, ONLY: prt_level,lunout
 
     IMPLICIT NONE
@@ -45,4 +46,6 @@
 
 !--------------------------------------------------------
+    CHARACTER (len = 20)  :: modname = 'readchlorophyll'
+    CHARACTER (len = 80)  :: abort_message
 
 !--only read file if beginning of run or start of new month
@@ -56,8 +59,7 @@
     CALL nf95_gw_var(ncid_in, varid, longitude)
     n_lon = size(longitude)
-!    print *, 'LON chlorophyll=', n_lon, longitude
     IF (n_lon.NE.nbp_lon) THEN
-       print *,'Le nombre de lon n est pas egal a nbp_lon'
-       STOP
+       abort_message='Le nombre de lon n est pas egal a nbp_lon'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -65,8 +67,7 @@
     CALL nf95_gw_var(ncid_in, varid, latitude)
     n_lat = size(latitude)
-!    print *, 'LAT chlorophyll=', n_lat, latitude
     IF (n_lat.NE.nbp_lat) THEN 
-       print *,'Le nombre de lat n est pas egal a jnbp_lat'
-       STOP
+       abort_message='Le nombre de lat n est pas egal a jnbp_lat'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -74,8 +75,7 @@
     CALL nf95_gw_var(ncid_in, varid, time)
     n_month = size(time)
-!    print *, 'TIME aerosol strato=', n_month, time
     IF (n_month.NE.12) THEN 
-       print *,'Le nombre de month n est pas egal a 12'
-       STOP
+       abort_message='Le nombre de month n est pas egal a 12'
+       CALL abort_physic(modname,abort_message,1)
     ENDIF
 
@@ -87,5 +87,5 @@
     CALL nf95_inq_varid(ncid_in, "CHL", varid)
     ncerr = nf90_get_var(ncid_in, varid, chlorocon)
-    print *,'code erreur readchlorophyll=', ncerr, varid
+    WRITE(lunout,*)'code erreur readchlorophyll=', ncerr, varid
 
     CALL nf95_close(ncid_in)
@@ -93,5 +93,5 @@
 !---select the correct month
     IF (mth_cur.LT.1.OR.mth_cur.GT.12) THEN
-      print *,'probleme avec le mois dans readchlorophyll =', mth_cur
+      WRITE(lunout,*)'probleme avec le mois dans readchlorophyll =', mth_cur
     ENDIF
     chlorocon_mois(:,:) = chlorocon(:,:,mth_cur)
@@ -100,5 +100,5 @@
     CALL grid2dTo1d_glo(chlorocon_mois,chlorocon_mois_glo)
 
-    print *,"chrolophyll current month",mth_cur
+    WRITE(lunout,*)"chrolophyll current month",mth_cur
     DO i=1,klon_glo
 !      if(isnan(chlorocon_mois_glo(i)))then ! isnan() is not in the Fortran standard...
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/regr_horiz_time_climoz_m.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 3605)
@@ -2,5 +2,5 @@
 
   USE interpolation,     ONLY: locate
-  USE mod_grid_phy_lmdz, ONLY: nlon_ou => nbp_lon, nlat_ou => nbp_lat
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, grid_type, unstructured
   USE nrtype,            ONLY: pi
   USE netcdf,   ONLY: NF90_CLOBBER, NF90_FLOAT,     NF90_GET_VAR, NF90_OPEN,   &
@@ -11,4 +11,5 @@
           NF95_CLOSE, NF95_ENDDEF,  NF95_PUT_ATT,   NF95_PUT_VAR, NF95_COPY_ATT
   USE print_control_mod, ONLY: lunout
+  USE dimphy
   IMPLICIT NONE
   PRIVATE
@@ -16,4 +17,10 @@
   REAL, PARAMETER :: deg2rad=pi/180.
   CHARACTER(LEN=13), PARAMETER :: vars_in(2)=['tro3         ','tro3_daylight']
+
+  INTEGER :: nlat_ou, nlon_ou
+  REAL, ALLOCATABLE :: latitude_glo(:)
+!$OMP THREADPRIVATE(latitude_glo)
+  INTEGER, ALLOCATABLE :: ind_cell_glo_glo(:)
+!$OMP THREADPRIVATE(ind_cell_glo_glo)
 
 CONTAINS
@@ -52,5 +59,6 @@
   USE assert_m,           ONLY: assert
   USE cal_tools_m,        ONLY: year_len, mid_month
-  USE control_mod,        ONLY: anneeref
+!!  USE control_mod,        ONLY: anneeref
+  USE time_phylmdz_mod,   ONLY: annee_ref
   USE ioipsl,             ONLY: ioget_year_len, ioget_calendar
   USE regr_conserv_m,     ONLY: regr_conserv
@@ -58,4 +66,11 @@
   USE regular_lonlat_mod, ONLY: boundslon_reg, boundslat_reg, south, west, east
   USE slopes_m,           ONLY: slopes
+#ifdef CPP_XIOS
+  USE xios
+#endif
+  USE mod_phys_lmdz_para, ONLY: is_mpi_root, is_master, is_omp_master, gather, gather_mpi, bcast_mpi, klon_mpi
+  USE geometry_mod, ONLY : latitude_deg, ind_cell_glo
+  USE mod_grid_phy_lmdz, ONLY: klon_glo
+
 !-------------------------------------------------------------------------------
 ! Arguments:
@@ -83,5 +98,7 @@
   CHARACTER(LEN=20) :: cal_in              ! Calendar
   REAL, ALLOCATABLE :: o3_in3(:,:,:,:,:)   ! Ozone climatologies
+  REAL, ALLOCATABLE :: o3_in3bis(:,:,:,:,:)   ! Ozone climatologies
   REAL, ALLOCATABLE :: o3_in2  (:,:,:,:)   ! Ozone climatologies
+  REAL, ALLOCATABLE :: o3_in2bis(:,:,:,:,:)   ! Ozone climatologies
   ! last index: 1 for the day-night average, 2 for the daylight field.
   REAL :: NaN
@@ -91,6 +108,9 @@
   REAL, ALLOCATABLE :: o3_regr_lonlat(:,:,:,:,:) ! (nlon_ou,nlat_ou,:,0:13   ,:)
   REAL, ALLOCATABLE :: o3_out3       (:,:,:,:,:) ! (nlon_ou,nlat_ou,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out3_glo   (:,:,:,:) !   (nbp_lat,:,ntim_ou,:)
   REAL, ALLOCATABLE :: o3_regr_lat     (:,:,:,:) !         (nlat_in,:,0:13   ,:)
   REAL, ALLOCATABLE :: o3_out2         (:,:,:,:) !         (nlat_ou,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out2_glo     (:,:,:,:) !         (nbp_lat,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out          (:,:,:,:) !         (nbp_lat,:,ntim_ou,:)
 ! Dimension number  | Interval                | Contains  | For variables:
 !   1 (longitude)   | [rlonu(i-1), rlonu(i)]  | rlonv(i)  | all
